<?php
namespace Elbotrade\Bundle\ContentBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class CertificateCategoryBackendController extends CertificateCategoryController
{

    /**
     * @Route("/elbotrade/certificate-cateogry/backend/list", name="elbotrade_certificate_category_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        return parent::indexAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/certificate-cateogry/backend/show/{id}", name="elbotrade_certificate_category_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/certificate-cateogry/backend/create", name="elbotrade_certificate_category_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $certificateCategoryManager = $this->get('elbotrade.content_bundle.certificate_category_manager');

        $certificateCategory = $certificateCategoryManager->createCertificateCategory();

        $form = $this->createForm(
            $this->get('elbotrade_content.certificate_category.form.type'), null, ['action' => $this->generateUrl('elbotrade_certificate_category_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $certificateCategoryManager = $this->get('elbotrade.content_bundle.certificate_category_manager');
            if ($certificateCategoryId = $certificateCategoryManager->handleCertificateCategoryForm($form, $certificateCategory, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_certificate_category_backend_list', ['id' => $certificateCategoryId]));
                return $response;
            }
        }

        $form->setData($certificateCategory);

        return [
            'form' => $form->createView(),
        ];

    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/certificate-cateogry/backend/update/{id}", name="elbotrade_certificate_category_backend_update")
     * @Template()
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $certificateCategoryFinder = $this->get('elbotrade.content_bundle.certificate_category_finder');

        $certificateCategory = $certificateCategoryFinder->findCertificateCategory($id);

        $form = $this->createForm(
            $this->get('elbotrade_content.certificate_category.form.type'), null, ['action' => $this->generateUrl('elbotrade_certificate_category_backend_update', ['id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $certificateCategoryManager = $this->get('elbotrade.content_bundle.certificate_category_manager');
            if ($certificateCategoryId = $certificateCategoryManager->handleCertificateCategoryForm($form, $certificateCategory, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_certificate_category_backend_show', ['id' => $certificateCategoryId]));
                return $response;
            }
        }

        $form->setData($certificateCategory);

        return [
            'form' => $form->createView(),
//            'images' => $certificateCategory->getImage() ? $certificateCategory->getImage() : [],
        ];

    }

    /**
     * @Route("/elbotrade/certificate-cateogry/backend/delete/{id}", name="elbotrade_certificate_category_backend_delete")
     */
    public function deleteAction($id)
    {

        $certificateCategory = $this->get('elbotrade.content_bundle.certificate_category_finder')->findCertificateCategory($id);

        $this->getDoctrine()->getManager()->remove($certificateCategory);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Certificate category Deleted');

        return $this->redirect($this->generateUrl('elbotrade_certificate_category_backend_list'));
    }
}